<template>
    <div>
        <v-card tile flat>
            <v-row class="px-5" style="margin-top: -2vh; align-items: center;">
                <v-spacer></v-spacer>
                <v-btn class="add" depressed @click.stop="setExtraDialog()">
                    + Agregar Subcategoría
                </v-btn>
            </v-row>
            <v-tabs background-color="transparent" grow v-model="tab">
                <v-tabs-slider></v-tabs-slider>
                <v-tab
                    v-for="(lang, key) in langsMenu"
                    :key="key"
                    style="font-weight:bold; font-size: small; border-radius: 0"
                >
                    {{ lang.language }}
                </v-tab>
            </v-tabs>
            <v-tabs-items v-model="tab">
                <v-tab-item v-for="(lang, key) in langsMenu" :key="key">
                    <v-data-table
                        mobile-breakpoint="0"
                        fixed-header
                        :headers="headers"
                        :items="arrayExtras"
                        :loading="loading"
                        :items-per-page="5"
                    >
                        <template v-slot:item="row">
                            <tr>
                                <td>{{ row.index + 1 }}</td>
                                <td>
                                    {{ extrasFromFire.find(extra => extra.id === row.item).name }}
                                </td>
                                <td>
                                    {{
                                        auxCombineExtras[row.item] && auxCombineExtras[row.item].languages.has(lang.id)
                                            ? auxCombineExtras[row.item].languages.get(lang.id).text
                                            : undefined
                                    }}
                                </td>
                                <td>
                                    {{
                                        auxCombineExtras[row.item] && auxCombineExtras[row.item].prices.has(lang.id)
                                            ? auxCombineExtras[row.item].prices.get(lang.id).amount
                                            : undefined
                                    }}
                                </td>
                                <td>
                                    <v-row>
                                        <HexButton
                                            class="small-button btnHex"
                                            @click="
                                                setExtraDialog(
                                                    row.item,
                                                    extrasFromFire.find(extra => extra.id === row.item).name
                                                )
                                            "
                                        >
                                            <v-icon>mdi-pencil</v-icon>
                                        </HexButton>
                                        <HexButton
                                            class="small-button btnHex"
                                            @click="
                                                $emit(
                                                    'deleteExtra',
                                                    menuId,
                                                    ingredient.id,
                                                    row.item,
                                                    extrasFromFire.find(extra => extra.id === row.item).name
                                                )
                                            "
                                        >
                                            <v-icon>mdi-delete</v-icon>
                                        </HexButton>
                                    </v-row>
                                </td>
                            </tr>
                        </template>
                    </v-data-table>
                </v-tab-item>
            </v-tabs-items>
        </v-card>
        <v-dialog v-model="dialog" max-width="600px">
            <v-card tile>
                <v-card-title>
                    <span class="headline">{{ auxExtraIngredient.name ? auxExtraIngredient.name : 'Agregar' }}</span>
                </v-card-title>
                <v-container class="px-7">
                    <v-form v-model="valid" ref="form">
                        <v-row>
                            <v-col>
                                <v-text-field
                                    label="Nombre"
                                    v-model="auxExtraIngredient.name"
                                    :rules="[v => (v && !!v.trim()) || 'Campo requerido']"
                                    hide-details
                                    required
                                ></v-text-field>
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col>
                                <span class="label">Configuraciones por idioma</span>
                                <v-tabs background-color="transparent" grow v-model="tab2">
                                    <v-tabs-slider></v-tabs-slider>
                                    <v-tab
                                        v-for="(lang, key) in langsMenu"
                                        :key="key"
                                        style="font-weight:bold; font-size: small; border-radius: 0"
                                    >
                                        {{ lang.language }}
                                    </v-tab>
                                </v-tabs>
                                <v-tabs-items v-model="tab2">
                                    <v-tab-item v-for="(lang, key) in langsMenu" :key="key" eager>
                                        <v-card flat style="overflow: hidden;">
                                            <v-text-field
                                                label="Nombre"
                                                :value="
                                                    langsExtraFromComponent.has(lang.id)
                                                        ? langsExtraFromComponent.get(lang.id).text
                                                        : undefined
                                                "
                                                @input="changeLangText($event, lang)"
                                                :rules="[v => (v && !!v.trim()) || 'Campo requerido']"
                                                row-height="20"
                                                rows="2"
                                                auto-grow
                                            ></v-text-field>
                                            <v-text-field
                                                label="Precio"
                                                type="number"
                                                :value="
                                                    pricesExtrasFromComponent.has(lang.id)
                                                        ? pricesExtrasFromComponent.get(lang.id).amount
                                                        : undefined
                                                "
                                                @input="changePriceAmount($event, lang)"
                                                :rules="[v => v >= 0 || 'El precio no puede ser negativo']"
                                                row-height="20"
                                                rows="2"
                                                auto-grow
                                            ></v-text-field>
                                        </v-card>
                                    </v-tab-item>
                                </v-tabs-items>
                            </v-col>
                        </v-row>
                    </v-form>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn class="add" text @click="closeWindow()">
                            Cancelar
                        </v-btn>

                        <v-btn class="add" :disabled="!valid" text @click="saveExtra(auxExtraIngredient)">
                            Guardar
                        </v-btn>
                    </v-card-actions>
                </v-container>
            </v-card>
        </v-dialog>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { ExtraIngredient as ExtraIngredientModel } from '@/model/menu/ExtraIngredient';
import { Price as PriceModel } from '@/model/menu/Price';
import { LangMenu } from '@/model/menu/LangMenu';
import { LangText } from '@/model/LangText';
import { db } from '@/config/firebase';
import {
    INGREDIENTS,
    MENUS,
    INGREDIENT_EXTRA,
    INGREDIENT_EXTRA_NAMES,
    INGREDIENT_EXTRA_PRICES
} from '@/config/collectionsName';
import { serializeLangText, serializePrice } from '@/config/serializables';
import HexButton from '@/components/commons/HexButton.vue';
import { Ingredient as IngredientModel } from '@/model/menu/Ingredient';

@Component({ components: { HexButton } })
export default class ExtraIngredient extends Vue {
    @Prop({ required: true })
    ingredient!: IngredientModel;
    @Prop({ required: true })
    extrasFromFire!: ExtraIngredientModel[];
    @Prop({ required: true })
    langsMenu!: LangMenu[];
    @Prop({ required: true })
    menuId!: string;

    tab = null;
    tab2 = null;
    valid = true;
    loading = false;
    dialog = false;
    combineExtrasFromFire: { [key: string]: { languages: LangText[]; prices: PriceModel[] } } = {};
    langsExtrasFromComponent: Map<string, LangText> = new Map();
    pricesExtrasFromComponent: Map<string, PriceModel> = new Map();
    extraIngredient: ExtraIngredientModel = new ExtraIngredientModel('', '');
    auxExtraIngredient: ExtraIngredientModel = new ExtraIngredientModel('', '');
    langsExtraFromComponent: Map<string, LangText> = new Map();
    pricesExtraFromComponent: Map<string, PriceModel> = new Map();
    auxCombineExtras: {
        [key: string]: { languages: Map<string, LangText>; prices: Map<string, PriceModel> };
    } = {};
    combineExtras: {
        [key: string]: { languages: Map<string, LangText>; prices: Map<string, PriceModel> };
    } = {};
    arrayExtras: string[] = [];

    headers = [
        {
            text: 'N°',
            sortable: false,
            value: 'key',
            class: 'header'
        },
        {
            text: 'Categoría',
            sortable: false,
            value: 'name',
            class: 'header'
        },
        {
            text: 'Nombre',
            sortable: false,
            value: 'text',
            class: 'header'
        },
        {
            text: 'Precio',
            sortable: false,
            value: 'amount',
            class: 'header'
        },
        {
            text: 'Acciones',
            sortable: false,
            value: 'id',
            class: 'header'
        }
    ];

    setExtraDialog(key?: string, name?: string) {
        this.auxExtraIngredient = new ExtraIngredientModel('', '');
        this.langsExtraFromComponent = new Map();
        this.pricesExtrasFromComponent = new Map();
        if (key && name) {
            this.tab2 = this.tab;
            this.auxExtraIngredient = new ExtraIngredientModel(key, name);
            this.langsExtraFromComponent = new Map(this.auxCombineExtras[key].languages);
            this.pricesExtrasFromComponent = new Map(this.auxCombineExtras[key].prices);
        }
        this.dialog = true;
    }

    changeLangText(input: string, lang: LangMenu) {
        this.langsExtraFromComponent.set(lang.id, new LangText(lang.id, lang.language, input));
    }

    changePriceAmount(input: number, lang: LangMenu) {
        this.pricesExtrasFromComponent.set(lang.id, new PriceModel(lang.id, Number(input), lang.currency));
    }

    async closeWindow() {
        this.dialog = false;
        this.auxExtraIngredient = Object.assign(this.auxExtraIngredient, this.extraIngredient);
        if (this.extraIngredient.id) {
            (this.$refs.form as Vue & { reset: () => '' }).reset();
        }
    }

    saveExtra(extra: ExtraIngredientModel) {
        this.loading = true;
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid) {
            const langExtraToFire = Array.from(this.langsExtraFromComponent.values()).filter(lang => lang.text);
            const pricesExtraToFire = Array.from(this.pricesExtrasFromComponent.values());
            this.$emit('saveExtra', this.ingredient.id, extra, langExtraToFire, pricesExtraToFire);
            if (extra.id) {
                this.auxCombineExtras[extra.id].languages = this.langsExtraFromComponent;
                this.auxCombineExtras[extra.id].prices = this.pricesExtrasFromComponent;
            }
        }
        this.dialog = false;
        this.loading = false;
    }

    initCombine(extraId: string) {
        this.combineExtras[extraId] = {
            languages: new Map(this.combineExtrasFromFire[extraId].languages.map(lang => [lang.id, lang])),
            prices: new Map(this.combineExtrasFromFire[extraId].prices.map(price => [price.id, price]))
        };
    }

    @Watch('extrasFromFire')
    async initExtras() {
        this.loading = true;
        this.combineExtrasFromFire = {};
        this.combineExtras = {};
        if (this.extrasFromFire && this.extrasFromFire.length > 0) {
            for await (const extra of this.extrasFromFire) {
                this.combineExtrasFromFire[extra.id] = { languages: [], prices: [] };

                const ref = db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(INGREDIENTS)
                    .doc(this.ingredient.id)
                    .collection(INGREDIENT_EXTRA)
                    .doc(extra.id);

                await this.$bind(
                    `combineExtrasFromFire.${extra.id}.languages`,
                    ref.collection(INGREDIENT_EXTRA_NAMES),
                    {
                        serialize: serializeLangText
                    }
                );

                await this.$bind(`combineExtrasFromFire.${extra.id}.prices`, ref.collection(INGREDIENT_EXTRA_PRICES), {
                    serialize: serializePrice
                });

                this.initCombine(extra.id);
            }
        }
        this.langsExtraFromComponent = new Map();
        this.pricesExtrasFromComponent = new Map();
        this.auxCombineExtras = this.combineExtras;
        this.arrayExtras = Object.keys(this.auxCombineExtras);
        this.loading = false;
    }

    async mounted() {
        await this.initExtras();
    }
}
</script>

<style type="text/css"></style>
